function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, Index, JoinColumn, Column, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { id } from "../id.js";
export let AbuseUserReport = class AbuseUserReport {
    id;
    createdAt;
    targetUserId;
    targetUser;
    reporterId;
    reporter;
    assigneeId;
    assignee;
    resolved;
    forwarded;
    comment;
    //#region Denormalized fields
    targetUserHost;
    reporterHost;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], AbuseUserReport.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The created date of the AbuseUserReport."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], AbuseUserReport.prototype, "createdAt", void 0);
_ts_decorate([
    Index(),
    Column(id()),
    _ts_metadata("design:type", Object)
], AbuseUserReport.prototype, "targetUserId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], AbuseUserReport.prototype, "targetUser", void 0);
_ts_decorate([
    Index(),
    Column(id()),
    _ts_metadata("design:type", Object)
], AbuseUserReport.prototype, "reporterId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], AbuseUserReport.prototype, "reporter", void 0);
_ts_decorate([
    Column({
        ...id(),
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], AbuseUserReport.prototype, "assigneeId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "SET NULL"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], AbuseUserReport.prototype, "assignee", void 0);
_ts_decorate([
    Index(),
    Column("boolean", {
        default: false
    }),
    _ts_metadata("design:type", Boolean)
], AbuseUserReport.prototype, "resolved", void 0);
_ts_decorate([
    Column("boolean", {
        default: false
    }),
    _ts_metadata("design:type", Boolean)
], AbuseUserReport.prototype, "forwarded", void 0);
_ts_decorate([
    Column("varchar", {
        length: 2048
    }),
    _ts_metadata("design:type", String)
], AbuseUserReport.prototype, "comment", void 0);
_ts_decorate([
    Index(),
    Column("varchar", {
        length: 512,
        nullable: true,
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], AbuseUserReport.prototype, "targetUserHost", void 0);
_ts_decorate([
    Index(),
    Column("varchar", {
        length: 512,
        nullable: true,
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], AbuseUserReport.prototype, "reporterHost", void 0);
AbuseUserReport = _ts_decorate([
    Entity()
], AbuseUserReport);
